=begin
#YNAB API Endpoints

#Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module YNAB
  class PayeeLocationsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Single payee location
    # Returns a single payee location
    # @param budget_id The id of the budget. \&quot;last-used\&quot; can be used to specify the last used budget and \&quot;default\&quot; can be used if default budget selection is enabled (see: https://api.youneedabudget.com/#oauth-default-budget).
    # @param payee_location_id id of payee location
    # @param [Hash] opts the optional parameters
    # @return [PayeeLocationResponse]
    def get_payee_location_by_id(budget_id, payee_location_id, opts = {})
      data, _status_code, _headers = get_payee_location_by_id_with_http_info(budget_id, payee_location_id, opts)
      data
    end

    # Single payee location
    # Returns a single payee location
    # @param budget_id The id of the budget. \&quot;last-used\&quot; can be used to specify the last used budget and \&quot;default\&quot; can be used if default budget selection is enabled (see: https://api.youneedabudget.com/#oauth-default-budget).
    # @param payee_location_id id of payee location
    # @param [Hash] opts the optional parameters
    # @return [Array<(PayeeLocationResponse, Fixnum, Hash)>] PayeeLocationResponse data, response status code and response headers
    def get_payee_location_by_id_with_http_info(budget_id, payee_location_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayeeLocationsApi.get_payee_location_by_id ...'
      end
      # verify the required parameter 'budget_id' is set
      if @api_client.config.client_side_validation && budget_id.nil?
        fail ArgumentError, "Missing the required parameter 'budget_id' when calling PayeeLocationsApi.get_payee_location_by_id"
      end
      # verify the required parameter 'payee_location_id' is set
      if @api_client.config.client_side_validation && payee_location_id.nil?
        fail ArgumentError, "Missing the required parameter 'payee_location_id' when calling PayeeLocationsApi.get_payee_location_by_id"
      end
      # resource path
      local_var_path = '/budgets/{budget_id}/payee_locations/{payee_location_id}'.sub('{' + 'budget_id' + '}', budget_id.to_s).sub('{' + 'payee_location_id' + '}', payee_location_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['bearer']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PayeeLocationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayeeLocationsApi#get_payee_location_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List payee locations
    # Returns all payee locations
    # @param budget_id The id of the budget. \&quot;last-used\&quot; can be used to specify the last used budget and \&quot;default\&quot; can be used if default budget selection is enabled (see: https://api.youneedabudget.com/#oauth-default-budget).
    # @param [Hash] opts the optional parameters
    # @return [PayeeLocationsResponse]
    def get_payee_locations(budget_id, opts = {})
      data, _status_code, _headers = get_payee_locations_with_http_info(budget_id, opts)
      data
    end

    # List payee locations
    # Returns all payee locations
    # @param budget_id The id of the budget. \&quot;last-used\&quot; can be used to specify the last used budget and \&quot;default\&quot; can be used if default budget selection is enabled (see: https://api.youneedabudget.com/#oauth-default-budget).
    # @param [Hash] opts the optional parameters
    # @return [Array<(PayeeLocationsResponse, Fixnum, Hash)>] PayeeLocationsResponse data, response status code and response headers
    def get_payee_locations_with_http_info(budget_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayeeLocationsApi.get_payee_locations ...'
      end
      # verify the required parameter 'budget_id' is set
      if @api_client.config.client_side_validation && budget_id.nil?
        fail ArgumentError, "Missing the required parameter 'budget_id' when calling PayeeLocationsApi.get_payee_locations"
      end
      # resource path
      local_var_path = '/budgets/{budget_id}/payee_locations'.sub('{' + 'budget_id' + '}', budget_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['bearer']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PayeeLocationsResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayeeLocationsApi#get_payee_locations\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List locations for a payee
    # Returns all payee locations for a specified payee
    # @param budget_id The id of the budget. \&quot;last-used\&quot; can be used to specify the last used budget and \&quot;default\&quot; can be used if default budget selection is enabled (see: https://api.youneedabudget.com/#oauth-default-budget).
    # @param payee_id id of payee
    # @param [Hash] opts the optional parameters
    # @return [PayeeLocationsResponse]
    def get_payee_locations_by_payee(budget_id, payee_id, opts = {})
      data, _status_code, _headers = get_payee_locations_by_payee_with_http_info(budget_id, payee_id, opts)
      data
    end

    # List locations for a payee
    # Returns all payee locations for a specified payee
    # @param budget_id The id of the budget. \&quot;last-used\&quot; can be used to specify the last used budget and \&quot;default\&quot; can be used if default budget selection is enabled (see: https://api.youneedabudget.com/#oauth-default-budget).
    # @param payee_id id of payee
    # @param [Hash] opts the optional parameters
    # @return [Array<(PayeeLocationsResponse, Fixnum, Hash)>] PayeeLocationsResponse data, response status code and response headers
    def get_payee_locations_by_payee_with_http_info(budget_id, payee_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayeeLocationsApi.get_payee_locations_by_payee ...'
      end
      # verify the required parameter 'budget_id' is set
      if @api_client.config.client_side_validation && budget_id.nil?
        fail ArgumentError, "Missing the required parameter 'budget_id' when calling PayeeLocationsApi.get_payee_locations_by_payee"
      end
      # verify the required parameter 'payee_id' is set
      if @api_client.config.client_side_validation && payee_id.nil?
        fail ArgumentError, "Missing the required parameter 'payee_id' when calling PayeeLocationsApi.get_payee_locations_by_payee"
      end
      # resource path
      local_var_path = '/budgets/{budget_id}/payees/{payee_id}/payee_locations'.sub('{' + 'budget_id' + '}', budget_id.to_s).sub('{' + 'payee_id' + '}', payee_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['bearer']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PayeeLocationsResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayeeLocationsApi#get_payee_locations_by_payee\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
